<template>
  <v-dialog v-model="search.moreDetailsDialogOpened" width="auto" max-width="1000">
    <v-card v-if="search.selectedItem" class="pa-2">
      <v-card-title>{{ search.selectedItem.getFullName() }}</v-card-title>
      <v-card-text>
        <table style="border-spacing: 16px 4px">
          <tbody>
            <tr>
              <td>{{ $t("createIdent.search.result.moreDetails.kitAccountLabel") }}</td>
              <td>{{ search.selectedItem.kitAccount }}</td>
            </tr>
            <tr>
              <td>{{ $t("createIdent.search.result.moreDetails.firstNameLabel") }}</td>
              <td>{{ search.selectedItem.firstName }}</td>
            </tr>
            <tr>
              <td>{{ $t("createIdent.search.result.moreDetails.lastNameLabel") }}</td>
              <td>{{ search.selectedItem.lastName }}</td>
            </tr>
            <tr>
              <td>{{ $t("createIdent.search.result.moreDetails.departmentLabel") }}</td>
              <td>{{ search.selectedItem.department }}</td>
            </tr>
            <tr>
              <td>{{ $t("createIdent.search.result.moreDetails.primaryEmailAddressLabel") }}</td>
              <td>{{ search.selectedItem.primaryEmail }}</td>
            </tr>
            <tr v-for="mail in search.selectedItem.emailAddresses" :key="mail">
              <td>{{ $t("createIdent.search.result.moreDetails.emailAddressLabel") }}</td>
              <td>{{ mail }}</td>
            </tr>
          </tbody>
        </table>
      </v-card-text>
      <v-card-actions>
        <v-btn color="secondary" block @click="search.moreDetailsDialogOpened = false">
          {{ $t("dialog.closeButton") }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog
    v-model="identify.newIdentification.documentIdentifierHintOpened"
    width="auto"
    :max-width="identify.dialogWidth"
  >
    <v-card>
      <v-card-title>{{ $t("createIdent.create.documentIdentifierHint.title") }}</v-card-title>
      <v-card-text>
        <hyphenated-justified-text class="mb-2">
          {{ $t("createIdent.create.documentIdentifierHint.text") }}
        </hyphenated-justified-text>
        <a href="https://www.consilium.europa.eu/prado/de/search-by-document-country.html" target="_blank"
          >https://www.consilium.europa.eu/prado/de/search-by-document-country.html</a
        >
        <div class="d-flex justify-center">
          <img
            :src="getAssetUrl(`${identify.newIdentification.form.document_type}.png`)"
            alt="Helpful image about where the document number is located"
            class="fill-height mt-4"
          />
        </div>
      </v-card-text>
      <v-card-actions class="pa-4">
        <v-spacer />
        <v-btn
          color="kitblack"
          variant="flat"
          @click="identify.newIdentification['documentIdentifierHintOpened'] = false"
        >
          {{ $t(`dialog.closeButton`) }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="identify.dialogOpened" width="auto" :max-width="identify.dialogWidth">
    <v-card>
      <v-card-title>
        {{
          $t("createIdent.create.title", {
            name: search.selectedItem?.getFullName(),
          })
        }}
      </v-card-title>
      <v-card-text class="px-2 px-sm-6 pt-2">
        <div v-if="identify.loading" class="text-center">
          <v-progress-circular indeterminate class="ma-auto" />
        </div>

        <div v-else-if="identify.page === IdentifyPage.Existing || identify.page === IdentifyPage.Success">
          <v-container>
            <v-row>
              <v-col class="py-0">
                <hyphenated-text class="text-h6">
                  {{
                    $t(`createIdent.create.${identify.page === IdentifyPage.Existing ? "existing" : "success"}.title`, {
                      name: search.selectedItem?.getFullName(),
                    })
                  }}
                </hyphenated-text>
              </v-col>
            </v-row>
            <v-row>
              <v-col>
                <hyphenated-justified-text>
                  {{
                    $t(
                      `createIdent.create.${identify.page === IdentifyPage.Existing ? "existing" : "success"}.description`
                    )
                  }}
                </hyphenated-justified-text>
              </v-col>
            </v-row>
            <v-row>
              <v-col v-for="(result, index) in identify.results?.identifications" :key="index">
                <v-card color="rgb(var(--v-theme-on-surface-variant))">
                  <v-card-title>
                    <icon-with-text :icon="result.documentType.icon" size="small" class="justify-center">
                      {{ result.commonName }}
                    </icon-with-text>
                  </v-card-title>
                  <v-card-text>
                    <v-container style="max-width: fit-content">
                      <v-row
                        v-for="entry in ['createdAt', 'validUntil']"
                        :key="entry"
                        class="text-no-wrap flex-sm-nowrap"
                      >
                        <v-col class="py-1"> {{ $t(`createIdent.create.existing.${entry}Label`) }}: </v-col>
                        <v-col class="py-1">
                          {{ result[entry as keyof ServiceDeskIdentification].toLocaleString() }}
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-card-text>
                </v-card>
              </v-col>
            </v-row>
          </v-container>
        </div>

        <div v-else-if="identify.page === IdentifyPage.Error">
          <v-container>
            <v-row>
              <v-col class="py-0">
                <hyphenated-text class="text-h6">
                  {{
                    $t(`createIdent.create.error.title`, {
                      name: search.selectedItem?.getFullName(),
                    })
                  }}
                </hyphenated-text>
              </v-col>
            </v-row>
            <v-row>
              <v-list>
                <v-list-item v-for="(error, idx) in identify.errors" :key="idx">
                  <template #prepend>
                    <v-icon icon="fas fa-circle-xmark" color="red" />
                  </template>
                  <hyphenated-text>{{ error }}</hyphenated-text>
                </v-list-item>
              </v-list>
            </v-row>
          </v-container>
        </div>

        <div v-else-if="identify.page === IdentifyPage.New">
          <v-form ref="newIdentificationForm" validate-on="blur">
            <v-container>
              <v-row>
                <v-col :cols="identify.newIdentification.cols">
                  <v-select
                    v-model="identify.newIdentification.form.document_type"
                    :items="documentTypeItems"
                    item-value="id"
                    :item-title="(item) => $t(`createIdent.create.documentType.${item.id}`)"
                    :label="$t('createIdent.create.documentType.selectTitle')"
                    :rules="[identify.newIdentification.rules.documentType]"
                    :hint="`<a href='https://www.consilium.europa.eu/prado/de/search-by-document-country.html' target='_blank' class='text-decoration-none'>${$t(
                      'createIdent.create.documentTypeHint'
                    )}</a>`"
                    persistent-hint
                    :menu-props="{ closeOnContentClick: true }"
                  >
                    <template #message="{ message }">
                      <!-- This is fine here as there is no user generated content -->
                      <!-- eslint-disable-next-line vue/no-v-html -->
                      <span v-html="message" />
                    </template>
                    <template #item="{ item }">
                      <v-list-item
                        class="overflow-hidden"
                        @click="identify.newIdentification.form.document_type = item.value"
                      >
                        <icon-with-text :icon="item.raw.icon" size="x-small" style="padding-left: 1px">
                          {{ item.title }}
                        </icon-with-text>
                      </v-list-item>
                    </template>
                    <template #selection="{ item }">
                      <div class="overflow-hidden">
                        <icon-with-text :icon="item.raw.icon" size="x-small" style="padding-left: 1px">
                          {{ item.title }}
                        </icon-with-text>
                      </div>
                    </template>
                  </v-select>
                </v-col>
                <v-col :cols="identify.newIdentification.cols">
                  <v-text-field
                    v-model="identify.newIdentification.form.document_identifier"
                    :label="$t('createIdent.create.documentIdentifier')"
                    :counter="5"
                    :rules="[identify.newIdentification.rules.documentIdentifier]"
                    :append-inner-icon="
                      getAssetUrl(`${identify.newIdentification.form.document_type}.png`) !== ''
                        ? 'far fa-question-circle'
                        : 'fas fa-nonexistent'
                    "
                    @click:append-inner="identify.newIdentification.documentIdentifierHintOpened = true"
                  />
                </v-col>
              </v-row>
              <v-row>
                <v-col>
                  <v-text-field
                    id="common-name-field"
                    v-model="identify.newIdentification.form.common_name"
                    :label="$t('createIdent.create.commonName')"
                    :counter="64"
                    persistent-counter
                    :rules="[identify.newIdentification.rules.commonName]"
                    readonly
                    :hint="$t('createIdent.create.commonNameHint')"
                    persistent-hint
                  />
                </v-col>
              </v-row>
              <v-row>
                <v-col>
                  <v-textarea
                    v-model="identify.newIdentification.form.auditor_remarks"
                    :label="$t('createIdent.create.auditorRemarks')"
                    :rules="[identify.newIdentification.rules.auditorRemarks]"
                  />
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </div>
      </v-card-text>
      <v-card-actions class="pa-4">
        <v-spacer />
        <v-btn color="kitblack" variant="flat" @click="identify.dialogOpened = false">
          {{ $t(`dialog.${identify.page === IdentifyPage.Success ? "close" : "abort"}Button`) }}
        </v-btn>
        <v-btn
          v-if="identify.page === IdentifyPage.Existing"
          color="primary"
          variant="flat"
          @click="identify.page = IdentifyPage.New"
        >
          {{ $t("dialog.nextButton") }}
        </v-btn>
        <v-btn
          v-else-if="identify.page === IdentifyPage.New"
          color="primary"
          variant="flat"
          :loading="identify.save.loading"
          :disabled="!identify.save.enabled"
          @click="submitNewIdentificationForm"
        >
          {{ $t("dialog.saveButton") }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <FunctionPage header-text-i18n-id="createIdent.search.header">
    <v-container>
      <v-row>
        <v-col>
          <v-text-field
            prepend-inner-icon="fas fa-magnifying-glass"
            :rules="[search.noSpacesRule]"
            :label="$t('createIdent.search.label')"
            :loading="search.loading"
            hide-details="auto"
            autofocus
            clearable
            @input="searchLDAP"
          />
        </v-col>
      </v-row>

      <v-row v-if="search.results.length === 0">
        <v-col>
          <v-card>
            <v-card-text class="text-center">
              <icon-with-text v-if="!search.loading && search.error !== null" icon="circle-xmark" color="red">
                {{ search.error.getLocalized($t) }}
              </icon-with-text>
              <div
                v-if="!search.loading && search.error === null"
                class="text-h6 font-italic font-weight-light ma-auto"
              >
                {{ $t("createIdent.search.noResults") }}
              </div>
              <v-progress-circular v-if="search.loading" indeterminate />
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
      <v-row v-else>
        <v-col v-for="item in search.results" :key="item.kitAccount" class="d-flex" style="flex-basis: 320px">
          <v-card class="flex-grow-1 d-flex flex-column pa-2 text-center">
            <v-card-title>
              <icon-with-text
                v-if="item.department === 'Studium'"
                icon="user-graduate"
                size="small"
                class="justify-center"
              >
                <template #before>
                  {{ item.getFullName() }}
                </template>
              </icon-with-text>
              <icon-with-text
                v-else-if="item.getAllMailAddresses().some((entry) => entry.endsWith('@partner.kit.edu'))"
                icon="handshake"
                size="small"
                class="justify-center"
              >
                <template #before>
                  {{ item.getFullNameWithDepartment() }}
                </template>
              </icon-with-text>
              <span v-else>{{ item.getFullNameWithDepartment() }}</span>
            </v-card-title>
            <v-card-subtitle class="font-weight-bold pb-2" style="font-size: 16px">
              <div class="pb-1" style="font-family: monospace">
                {{ item.kitAccount }}
              </div>
              <div>{{ item.primaryEmail }}</div>
            </v-card-subtitle>
            <v-card-actions class="ma-auto">
              <v-btn color="secondary" variant="flat" class="px-4" @click="openMoreDetails(item)">
                <v-icon icon="fas fa-circle-info" class="pr-2" />{{ $t("createIdent.search.result.moreDetailsButton") }}
              </v-btn>
              <v-btn color="primary" variant="flat" class="px-4" @click="openIdentify(item)">
                <v-icon icon="fas fa-id-card" class="pr-2" />{{ $t("createIdent.search.result.identifyButton") }}
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </FunctionPage>
</template>

<script lang="ts">
import { checkRuleResult, getAssetUrl, requestBackend, store } from "@/ts/common";
import { defineComponent } from "vue";
import {
  APILDAPSearchResultType,
  IdentificationDocumentTypeEnum,
  identificationDocumentTypeMap,
  IdentificationList,
  LDAPSearchResult,
  LDAPSearchResultType,
  NewIdentificationBody,
  RulesType,
  RuleType,
  ServiceDeskIdentification,
  ServiceDeskIdentificationType,
  VFormType,
} from "@/ts/types";
import IconWithText from "@/components/IconWithText.vue";
import { APIError, APIErrorType, IdentificationValidityError, IdentificationValidityErrorType } from "@/ts/errorTypes";
import { useDisplay } from "vuetify";
import HyphenatedJustifiedText from "@/components/HyphenatedJustifiedText.vue";
import HyphenatedText from "@/components/HyphenatedText.vue";
import FunctionPage from "@/components/FunctionPage.vue";

enum IdentifyPage {
  Existing,
  New,
  Success,
  Error,
}

type IdentData = {
  search: {
    loading: boolean;
    noSpacesRule: RuleType;
    results: Array<LDAPSearchResult>;
    error: APIError | null;
    selectedItem: LDAPSearchResult | null;
    moreDetailsDialogOpened: boolean;
  };
  identify: {
    dialogWidth: number;
    loading: boolean;
    results: IdentificationList<ServiceDeskIdentificationType, ServiceDeskIdentification> | null;
    dialogOpened: boolean;
    errors: Array<string>;
    errorRules: Array<() => Promise<boolean | string>>;
    page: IdentifyPage;
    newIdentification: {
      documentIdentifierHintOpened: boolean;
      cols: number;
      form: NewIdentificationBody;
      rules: RulesType;
    };
    save: {
      enabled: boolean;
      loading: boolean;
    };
  };
};

let searchDelayTimeout: ReturnType<typeof setTimeout>;

export default defineComponent({
  components: {
    FunctionPage,
    HyphenatedText,
    HyphenatedJustifiedText,
    IconWithText,
  },
  setup() {
    return {
      IdentifyPage,
      ServiceDeskIdentification,
      store: store,
      display: useDisplay(),
    };
  },
  data(): IdentData {
    return {
      search: {
        loading: false,
        noSpacesRule: (value: string) => {
          return /^[^ ]*$/.test(value) || this.$t("createIdent.search.rules.noSpacesAllowed");
        },
        results: [] as Array<LDAPSearchResult>,
        error: null as APIError | null,
        selectedItem: null as LDAPSearchResult | null,
        moreDetailsDialogOpened: false,
      },
      identify: {
        dialogWidth: 1000,
        loading: false,
        results: null as IdentificationList<ServiceDeskIdentificationType, ServiceDeskIdentification> | null,
        dialogOpened: false,
        errors: [] as Array<string>,
        errorRules: [
          () => {
            return this.checkNewIdentificationForm("kit_account");
          },
        ],
        page: IdentifyPage.Existing as IdentifyPage,
        newIdentification: {
          documentIdentifierHintOpened: false,
          cols: 12,
          form: {} as NewIdentificationBody,
          rules: {
            documentType: () => {
              return this.checkNewIdentificationForm("document_type");
            },
            documentIdentifier: () => {
              return this.checkNewIdentificationForm("document_identifier");
            },
            commonName: () => {
              return this.checkNewIdentificationForm("common_name");
            },
            auditorRemarks: () => {
              return this.checkNewIdentificationForm("auditor_remarks");
            },
          },
        },

        save: {
          enabled: false,
          loading: false,
        },
      },
    };
  },
  computed: {
    documentTypeItems() {
      return Object.values(identificationDocumentTypeMap).filter(
        (entry) => entry.id !== IdentificationDocumentTypeEnum.Unknown
      );
    },
  },
  watch: {
    "identify.newIdentification.form.document_type": function () {
      const ref = this.$refs.newIdentificationForm as VFormType;
      if (ref) {
        ref.validate();
      }
    },
  },
  beforeMount() {
    window.addEventListener("resize", this.resizeListener);
    this.resizeListener();
  },
  beforeUnmount() {
    window.removeEventListener("resize", this.resizeListener);
  },
  methods: {
    getAssetUrl,
    resizeListener: function () {
      this.identify.dialogWidth = Math.min(this.display.width.value - (this.display.mobile.value ? 16 : 32), 1000);
      this.identify.newIdentification.cols = this.display.mobile.value ? 12 : 6;
    },
    searchLDAP: function (searchChangedEvent: InputEvent) {
      if (searchDelayTimeout) {
        clearTimeout(searchDelayTimeout);
      }

      const target = searchChangedEvent.target as HTMLInputElement;
      if (!checkRuleResult(this.search.noSpacesRule(target.value))) {
        return;
      }

      searchDelayTimeout = setTimeout(() => {
        this.search.results = [];
        this.search.error = null;

        if (!target.value) {
          return;
        }

        this.search.loading = true;
        requestBackend<APILDAPSearchResultType>(`/servicedesk/search?q=${target.value}`)
          .then(
            (data: APILDAPSearchResultType) => {
              if (data.results) {
                this.search.results = data.results.map((entry: LDAPSearchResultType) => {
                  return new LDAPSearchResult(entry);
                });
              }
            },
            (error: APIErrorType) => {
              this.search.error = new APIError(error);
            }
          )
          .finally(() => {
            this.search.loading = false;
          });
      }, 250);
    },
    openMoreDetails: function (item: LDAPSearchResult) {
      this.search.selectedItem = item;
      this.search.moreDetailsDialogOpened = true;
    },
    openIdentify: async function (item: LDAPSearchResult) {
      this.search.selectedItem = item;

      if (item.kitAccount != this.identify.newIdentification.form.kit_account) {
        this.identify.newIdentification.form = {
          kit_account: this.search.selectedItem.kitAccount,
          document_type: IdentificationDocumentTypeEnum.IdentityCard,
          document_identifier: "",
          auditor_remarks: "",
          common_name: `${this.search.selectedItem.firstName} ${this.search.selectedItem.lastName}`,
        };
      }

      this.identify.page = IdentifyPage.Existing;
      this.identify.errors = [];
      this.identify.loading = true;
      this.identify.save.enabled = false;
      this.identify.dialogOpened = true;

      // Check if prohibitive error occurred
      for (const ruleFunction of this.identify.errorRules) {
        const result = await ruleFunction();

        // Error occurred of the result is a string, add to errors and load error page
        if (typeof result === "string") {
          this.identify.errors.push(result);
          this.identify.page = IdentifyPage.Error;
          this.identify.loading = false;
        }
      }

      // Exit early if an error occurred
      if (this.identify.errors.length > 0) {
        return;
      }

      this.requestExistingIdentifications().then(
        () => {
          if (!this.identify.results || this.identify.results.identifications.length === 0) {
            this.identify.page = IdentifyPage.New;
          }
          this.identify.loading = false;
        },
        () => {
          this.identify.loading = false;
        }
      );
    },
    requestExistingIdentifications: async function (): Promise<void> {
      return requestBackend<Array<ServiceDeskIdentificationType>>(
        `/servicedesk/identification/by-user/${this.search.selectedItem?.kitAccount}`
      ).then((data) => {
        this.identify.results = new IdentificationList(data, ServiceDeskIdentification);
      });
    },
    requestNewIdentification: async function (dryRun: boolean = false): Promise<boolean> {
      return requestBackend<null>("/servicedesk/identification/scc-sd-sectigo", {
        ...this.identify.newIdentification.form,
        ...{ dry_run: dryRun },
      }).then(
        () => true,
        (errors: Array<IdentificationValidityErrorType>) => {
          throw new IdentificationValidityError(errors);
        }
      );
    },
    checkNewIdentificationForm: async function (field: string): Promise<boolean | string> {
      return this.requestNewIdentification(true).then(
        () => {
          if (
            field === "auditor_remarks" &&
            this.identify.newIdentification.form.document_type === IdentificationDocumentTypeEnum.Other &&
            this.identify.newIdentification.form.auditor_remarks === ""
          ) {
            this.identify.save.enabled = false;
            return this.$t("createIdent.create.auditorRemarksEmptyWithDocTypeOtherError");
          }

          this.identify.save.enabled = true;
          return true;
        },
        (error: IdentificationValidityError) => {
          // At least one check failed, disable save.
          this.identify.save.enabled = false;

          if (error.checkFieldExists(field)) {
            return error.getLocalized(this.$t, field);
          }

          // Field does not exist, content is valid
          return true;
        }
      );
    },
    submitNewIdentificationForm: async function () {
      this.identify.save.loading = true;

      this.requestNewIdentification().then(
        () => {
          this.identify.save.loading = false;

          if (!this.search.selectedItem) {
            return;
          }

          this.requestExistingIdentifications().then(() => {
            this.identify.page = IdentifyPage.Success;
          });
        },
        () => {
          // This should never happen due to prior checking other than backend failures (those will create a backend error popup)
          this.identify.save.loading = false;
        }
      );
    },
  },
});
</script>

<style>
#common-name-field-messages {
  max-width: 75%;
}
</style>
